/*
	CGI Source for TextBoard.h

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.0
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#ifndef __TextBoard_h_
#define __TextBoard_h_

#include "MyCgi.h"

class TextBoard
{
private:
	int	iStart, iEnd;

protected:
	HEADER	*hdr;
	RECORD	*rcd;
	ENTRY	*iParam;
	char	*buf;
	char	fname[255];
	int	iBoardNum, iTextNum, iTotal;
	FILE	*fpt;

	/*
	** Config data from 'GuestBook.Conf'
	*/
	char	szBaseDir[MAX_STRING_LEN], szBbsDir[MAX_STRING_LEN], szEmail[MAX_STRING_LEN];
	char	szEraseDomain[MAX_STRING_LEN], szImageName[MAX_STRING_LEN];
	char	szPassword[MAX_STRING_LEN];

public:
	TextBoard();
	~TextBoard();

	virtual	void GetEnv();
	virtual stat ProcessConfig();
	stat IsGuestBookStart();
	void ShowInitHtmlPage();
	void ShowStartHtmlPage();

	int  GetTotalText();
	int  GetBoardNum();
	int  GetTextNum();

	char* GetBaseDir();
	char* GetBbsDir();
	char* GetEmail();
	char* GetEraseDomain();
	char* GetImageFileName();
	char* GetPassword();

	void GetScope();
	void ShowBoard();
	char* ItoA(int num, char *str);

	void ShowError(char *str);
};

#endif	/* end of TextBoard */
