/*
	CGI Source for TextPost.pp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: April 10, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: Visual C++ 4.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "TextPost.h"
#include <string.h>

TextPost::TextPost()
{
	cl		= 0;
	iIndex		= 0;
	whdomain	= NULL;
	whip		= NULL;
	browser		= NULL;
	tmp_time2	= NULL;
}

TextPost::~TextPost()
{
}

void TextPost::GetEnv()
{
	char *buf;
	int	i;

	/*
	** Get environment variable from HTTP
	*/
	whdomain = getenv("REMOTE_HOST");
	whip	 = getenv("REMOTE_ADDR");
	browser	 = getenv("HTTP_USER_AGENT");
	cl	 = atoi(getenv("CONTENT_LENGTH"));

	/*
	** Set time and date of writing
	*/
	tmp_time1 = time(0);
	tmp_time2 = localtime(&tmp_time1);
	strftime(whdate, 99, "%Y%m%d", tmp_time2);
	strftime(whtime, 99, "%H%M", tmp_time2);
	sprintf(szDate, "%s %s", whdate, whtime);	

	/*
	** Get BoardNum from 'QUERY_STRING'
	*/
	buf = getenv("QUERY_STRING");

	for (i=0; i<2; i++)
	{
		(iParam+i)->f_val = (char *)makeword(buf, '&');
		(iParam+i)->f_name = (char *)makeword((iParam+i)->f_val, '=');
	}

	/*
	** Get BoardNum and TextNum
	** IF TextNum == -1
	**	Do Posting
	** ELSE
	**	Do Correct
	*/
	iBoardNum = atoi((iParam+0)->f_val);
	iTextNum  = atoi((iParam+1)->f_val);

	/*
	** Get content
	*/
	for (i=0; cl && (!feof(stdin)); i++)
	{
		(iParam+i)->f_val	= fmakeword(stdin, '&', &cl);
		plustospace((iParam+i)->f_val);
		unescape_url((iParam+i)->f_val);
		(iParam+i)->f_name	= makeword((iParam+i)->f_val, '=');

#ifdef _DEBUG_
	printf("%s : %s%c<br>", (iParam+i)->f_name, (iParam+i)->f_val, LF);
#endif
	}

	/*
	** Get Config from 'GuestBook.conf'
	*/
	ProcessConfig();

	sprintf(fname, "%s", GetBbsDir());
}

stat TextPost::IsOkPost()
{
	/*
	** Show error message
	**	* Don't write own's name
	**	* Don't write title
	**	* Don't write comment
	*/
	if (strlen((iParam+0)->f_val) <= 0 ||
	    strlen((iParam+3)->f_val) <= 0 ||
	    strlen((iParam+4)->f_val) <= 0)
	{
		return	ERR;
	}

	return	OK;
}

void TextPost::ShowError()
{
	/*
	** Return result into HTML document
	** Just write into stdout and exit(0)
	*/
	printf("<html>%c", LF);
	printf("<head><title>Խ  2.13</title></head>%c", LF);
	printf("<body bgcolor=white>%c", LF);
	printf("<center>%c", LF);

	printf("<img border=0 src=%sImage/%s><br><br>%c", GetBaseDir(), GetImageFileName(), LF);

	printf("<img src=%sImage/line_ani.gif><br><br>%c", GetBaseDir(), LF);
        printf("<font size=3>湮 ̸, ,  ּ!!!</font><br>%c", LF);
	printf("<font size=3>You should write your name, title and comment!!!</font></center>%c", LF);
	printf("<br><br><br>%c", LF);

	printf("<center><a href=%scgi-bin/TextHtml.exe?BoardNum=%d><img border=0 src=%sImage/before.gif></a></center>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	exit(0);
}

void TextPost::GetFileName()
{
	/*
	** Make file name and path
	*/
	strcat(fname, "guestbook.dat");

	fpt = fopen(fname, "r+");

	/*
	** If file doesn't exist, create new file
	*/
	if (fpt == NULL)
	{
		fpt = fopen(fname, "w");

		sprintf(hdr->szTotal, "%d", 0);
		sprintf(hdr->szIndex, "%d", 0);
		fwrite(hdr, HEADER_SIZE, 1, fpt);

#ifdef _DEBUG_
	printf("fname : %s%c<br>", fname, LF);
	printf("hdr->szTotal : %s%c<br>", hdr->szTotal, LF);
	printf("hdr->szIndex : %s%c<br>", hdr->szIndex, LF);
#endif
	}
}

void TextPost::ReadHeader()
{
	fseek(fpt, 0L, SEEK_SET);
	fread(hdr, HEADER_SIZE, 1, fpt);	/* read header	*/

	sscanf(hdr->szIndex, "%d", &iIndex);
	iIndex++;

	sscanf(hdr->szTotal, "%d", &iTotal);
	iTotal++;

#ifdef _DEBUG_
	printf("iIndex = %d iTotal = %d%c<BR>", iIndex, iTotal, LF);
#endif
}
	
int TextPost::GetIndexText()
{
	return	iIndex;
}

int TextPost::GetLineText()
{
	int	iLine = 0;

	for (int i=0; i<(int)strlen((iParam+4)->f_val); i++)
	{
		if (*(((iParam+4)->f_val)+i) == CR)
		{
			iLine++;
		}
	}

	if (iLine == 0)
	{
		iLine++;
		return	iLine;
	}

	return	(iLine+1);
}

void TextPost::SetHeader()
{
	sprintf(hdr->szIndex, "%d", GetIndexText());
	sprintf(hdr->szTotal, "%d", GetTotalText());
	sprintf(hdr->szBoardNum, "%d", GetBoardNum());
	sprintf(hdr->szDummy, "%s", "");

	fseek(fpt, 0L, SEEK_SET);
	fwrite(hdr, HEADER_SIZE, 1, fpt);
}

void TextPost::SetRecord()
{
	sprintf(rcd->szNumber, "%d", GetTotalText());
	sprintf(rcd->szCount, "%4s", "0");
	sprintf(rcd->szLine, "%d", GetLineText());
	sprintf(rcd->szHtmlName, "%s%d.html", "guestbook", GetIndexText());

	strcpy(rcd->szName, (iParam+0)->f_val);
	strcpy(rcd->szEmail, (iParam+1)->f_val);
	strcpy(rcd->szHomePage, (iParam+2)->f_val);
	strcpy(rcd->szDate, whdate);
	strcpy(rcd->szTime, whtime);
	strcpy(rcd->szDomain, whdomain);
	strcpy(rcd->szTitle, (iParam+3)->f_val);

	fseek(fpt, 0L, SEEK_END);
	fwrite(rcd, RECORD_SIZE, 1, fpt);
	fclose(fpt);

	sprintf(hfname, "%s%s%d.html", GetBbsDir(), "guestbook", GetIndexText());

#ifdef _DEBUG_
	printf("rcd->szNumber = %s rcd->szCount = %s rcd->szLine = %s<br>%c",
		rcd->szNumber, rcd->szCount, rcd->szLine, LF);
	printf("rcd->szName = %s rcd->szEmail = %s rcd->szDate = %s rcd->szTitle = %s<br>%c",
		rcd->szName, rcd->szEmail, rcd->szDate, rcd->szTitle, LF);
	printf("hfname = %s<br>%c", hfname, LF);
#endif
}

void TextPost::MakeNewHtmlFile()
{
//	char	ch;

	/*
	** Show 'guestbook#.html' in the screen
	*/
	fpt = fopen(hfname, "w");

	if (fpt == NULL)
	{
		printf("Can't open %s.%c", hfname, LF);
		exit(1);
	}

	/*
	** Write contents in the file
	*/
	for (int i=0; i<(int)strlen((iParam+4)->f_val); i++)
	{
		if (*(((iParam+4)->f_val)+i) == CR)
		{
			fprintf(fpt, "<br>");
		}
		else
		{
			putc(*(((iParam+4)->f_val)+i), fpt);
		}
	}

	fclose(fpt);
}

void TextPost::ShowNewHtmlFile()
{
	char ch;

	/*
	** Show 'guestbook#.html' in the screen
	*/
	fpt = fopen(hfname, "r");
	
	if (fpt == NULL)
	{
		printf("Can't open %s.%c", hfname, LF);
		exit(1);
	}

	printf("<html>%c", LF);
	printf("<head><title>Խ  2.13</title></head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<center>%c", LF);
	printf("<table border=0><b><font size=-1>%s</font></b></caption>%c", rcd->szTitle, LF);

	/*
	** Jump a few lines
	*/
	printf("<tr><th>  </th></tr>%c", LF);
	printf("<tr><th>  </th></tr>%c", LF);

	printf("<tr><th><font size=-1> ۹ȣ </font></th><td><font size=-1>%4s</font></td><th><font size=-1> Ƚ </font></th><td><font size=-1>%4s</font></td></tr>%c",
		rcd->szNumber, rcd->szCount, LF);
	printf("<tr><th><font size=-1>۾</font></th><td><font size=-1>%s</font></td><th><font size=-1>۾¥</font></th><td><font size=-1>%s</font></td></tr>%c",
		rcd->szName, szDate, LF);
	printf("<tr><th><font size=-1>E-mail</font></th><td><a href=mailto:%s><font size=-1>%s</font></a></td>",
		rcd->szEmail, rcd->szEmail);
	printf("<th><font size=-1>URL</font></th><td><a href=http://%s><font size=-1>%s</font></a></td></tr>%c", whdomain, whdomain, LF);
	printf("<tr><th><font size=-1>Homepage</font></th><td><a href=%s><font size=-1>%s</font></a></td>%c", (iParam+2)->f_val, (iParam+2)->f_val, LF);
	printf("<th><font size=-1> ټ </font></th><td><font size=-1>%s</font></td></th></tr>%c", rcd->szLine, LF);
	printf("</table>%c", LF);

	printf("<img width=420 src=%sImage/blue_line.gif>%c", GetBaseDir(), LF);
	printf("<br><br>%c", LF);

	printf("<table border=0>%c", LF);
	printf("<tr><td><font size=-1>%c", LF);

	/*
	** Show contents in the file
	*/
	while ((ch = getc(fpt)) != EOF)
		putchar(ch);

	printf("</font></table>%c", LF);
	printf("<br>%c", LF);

	printf("<img src=%sImage/line.gif width=500><br>%c", GetBaseDir(), LF);
	printf("<font color=454545 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.13 Software Engineering Lab. All rights reserved.</br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a></br>%c", GetEmail(), GetEmail(), LF);
	printf("</font>%c", LF);

	printf("</center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	fclose(fpt);
}

void TextPost::GotoTextBoard()
{
	/*
	** Go to TextBoard
	*/
	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=%scgi-bin/TextBoard.exe?BoardNum=%d&TextNum=0><img src=%sImage/posting.gif border=0></a>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);
}

void TextPost::GetRecordFromFile()
{
	long	lSkip;
	fpos_t	pos;

	lSkip = HEADER_SIZE + RECORD_SIZE * (GetTextNum() - 1);

	/*
	** Jump to the location and get current file pointer
	*/
	fseek(fpt, lSkip, SEEK_SET);
	fgetpos(fpt, &pos);

	fread(rcd, RECORD_SIZE, 1, fpt);
	fsetpos(fpt, &pos);

	CorrectRecord();
}

void TextPost::CorrectRecord()
{
	sprintf(rcd->szLine, "%d", GetLineText());

	strcpy(rcd->szName, (iParam+0)->f_val);
	strcpy(rcd->szEmail, (iParam+1)->f_val);
	strcpy(rcd->szHomePage, (iParam+2)->f_val);
	strcpy(rcd->szDate, whdate);
	strcpy(rcd->szTime, whtime);
	strcpy(rcd->szDomain, whdomain);
	strcpy(rcd->szTitle, (iParam+3)->f_val);

	fwrite(rcd, RECORD_SIZE, 1, fpt);

	/*
	** Close 'guestbook.dat'
	*/
	fclose(fpt);
}

void TextPost::CorrectHtmlFile()
{
//	char	ch;

	/*
	** Show 'guestbook#.html' in the screen
	*/
	sprintf(hfname, "%s%s", GetBbsDir(), rcd->szHtmlName);
	fpt = fopen(hfname, "w");

	if (fpt == NULL)
	{
		printf("Can't open %s.%c", hfname, LF);
		exit(1);
	}

	/*
	** Write contents in the file
	*/
	for (int i=0; i<(int)strlen((iParam+4)->f_val); i++)
	{
		if (*(((iParam+4)->f_val)+i) == CR)
		{
			fprintf(fpt, "<br>");
		}
		else
		{
			putc(*(((iParam+4)->f_val)+i), fpt);
		}
	}
	
	fclose(fpt);
}


/*
** Program Entry
*/
void main()
{
	stat		result;
	TextPost*	MyTextPost;

	MyTextPost = new TextPost;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	MyTextPost->GetEnv();

	result = MyTextPost->IsOkPost();

	if (result == ERR)
	{
		MyTextPost->ShowError();
	}

	MyTextPost->GetFileName();

	if (MyTextPost->GetTextNum() == -1)
	{
		MyTextPost->ReadHeader();
		MyTextPost->SetHeader();
		MyTextPost->SetRecord();
		MyTextPost->MakeNewHtmlFile();
		MyTextPost->ShowNewHtmlFile();
		MyTextPost->GotoTextBoard();
	
	}
	else
	{
		MyTextPost->GetRecordFromFile();
		MyTextPost->CorrectRecord();
		MyTextPost->CorrectHtmlFile();
		MyTextPost->ShowNewHtmlFile();
		MyTextPost->GotoTextBoard();
	}

	delete MyTextPost;
}
